////////////////////////////////////////////////////////////////////////////
//
// VAf[^\.
// for SG12864A 128x64dot LCD
//
// by rubidesu 2017
// http://www.gatelink.co.jp/hw/
//
////////////////////////////////////////////////////////////////////////////

//NbNɂĉL̂ꂩLɂ.
#define _CLOCK_20MHZ_		//NbN20MHz.
//#define _CLOCK_18_432MHZ_	//NbN18.432MHz.

//tHg̑傫ɂĉL̂ꂩLɂ.
#define _FONT_BIG_		//6x8tHg.
//#define _FONT_SMALL_	//4x8tHg.

#include <16f877a.h>

#fuses hs,nowdt,noprotect,put,nobrownout,nolvp

#ifdef _CLOCK_20MHZ_
	#use delay(clock=20000000)
#endif //_CLOCK_20MHZ_
#ifdef _CLOCK_18_432MHZ_
	#use delay(clock=18432000)
#endif //_CLOCK_18_432MHZ_

#include "picdef.h"

#ifdef _FONT_BIG_
	#include "glcd_font.h"
#endif //_FONT_BIG_
#ifdef _FONT_SMALL_
	#include "glcd_font_4x8.h"
#endif //_FONT_SMALL_

#define LCD_D	PORTD_BIT
#define LCD_RES	PORTC_BIT.bit4
#define LCD_CS1	PORTB_BIT.bit0
#define LCD_CS2	PORTC_BIT.bit5
#define LCD_E	PORTB_BIT.bit1
#define LCD_RW	PORTB_BIT.bit2
#define LCD_DI	PORTB_BIT.bit3

#define LCD_CMD	0
#define LCD_DAT	1

#define RCV_MAX		64			//Mobt@TCY.
BYTE rcv_stack[RCV_MAX];		//Mobt@.
BYTE rcv_read = 0;				//Mobt@̃[h|C^.
BYTE rcv_write = 0;				//Mobt@̃Cg|C^.
BYTE rcv_buff;					//Mobt@󂯓npϐ.

struct BITSWAP sBitSwap;

//VAʐM֌W̃WX^.
#byte SPBRG = 0x99
#byte TXSTA = 0x98
#byte RCSTA = 0x18
#byte RCREG = 0x1a
#bit  RCIF  = 0x0c.5

//{[[g.
typedef struct tagBAUD_INFO{
	BYTE bBaudStr[12];
	BYTE bTXSTA;
	BYTE bRCSTA;
	BYTE bSPBRG;
} BAUD_INFO;

#ifdef _CLOCK_20MHZ_
	const BAUD_INFO BaudInfo[8] = {
		{"\r1200bps\r",		34, 144, 255 },	//BRGH=0.
		{"\r2400bps\r",		34, 144, 129 },	//BRGH=0.
		{"\r4800bps\r",		34, 144, 64	 },	//BRGH=0.
		{"\r9600bps\r",		38, 144, 129 },	//BRGH=1.
		{"\r19200bps\r",	38, 144, 64	 },	//BRGH=1.
		{"\r38400bps\r",	38, 144, 32	 },	//BRGH=1.
		{"\r57600bps\r",	38, 144, 21	 },	//BRGH=1.
		{"\r115200bps\r",	38, 144, 10	 }	//BRGH=1.
	};
#endif //_CLOCK_20MHZ_
#ifdef _CLOCK_18_432MHZ_
	const BAUD_INFO BaudInfo[8] = {
		{"\r1200bps\r",		34, 144, 239 },	//BRGH=0.
		{"\r2400bps\r",		34, 144, 119 },	//BRGH=0.
		{"\r4800bps\r",		34, 144, 59	 },	//BRGH=0.
		{"\r9600bps\r",		38, 144, 119 },	//BRGH=1.
		{"\r19200bps\r",	38, 144, 59	 },	//BRGH=1.
		{"\r38400bps\r",	38, 144, 29	 },	//BRGH=1.
		{"\r57600bps\r",	38, 144, 19	 },	//BRGH=1.
		{"\r115200bps\r",	38, 144, 9	 }	//BRGH=1.
	};
#endif //_CLOCK_18_432MHZ_

//DIPSW̏Ԃۑ.
BYTE bLastSW = 0xff;

////////////////////////////////////////////////////////////////////////////
void lcd_Write(BIT cs, BYTE code, BIT DIflag)
{
	LCD_CS1 = !cs;
	LCD_CS2 = cs;

	LCD_DI = DIflag;
	if(DIflag == LCD_DAT){
		LCD_D = code;
	}
	else{
		sBitSwap = code;
		LCD_D.bit0 = sBitSwap.bit7;
		LCD_D.bit1 = sBitSwap.bit6;
		LCD_D.bit2 = sBitSwap.bit5;
		LCD_D.bit3 = sBitSwap.bit4;
		LCD_D.bit4 = sBitSwap.bit3;
		LCD_D.bit5 = sBitSwap.bit2;
		LCD_D.bit6 = sBitSwap.bit1;
		LCD_D.bit7 = sBitSwap.bit0;
	}
	delay_us(1);
	LCD_E = 1;
	delay_us(1);
	LCD_E = 0;
	delay_us(5);
}

////////////////////////////////////////////////////////////////////////////
void lcd_Clear(BYTE data)
{
	BYTE page;
	BYTE column;

	for(page = 0; page < SCREEN_LINE_NUM; page++){
		lcd_Write(0, 0xB8 + page, LCD_CMD);
		lcd_Write(0, 0x40, LCD_CMD);

		lcd_Write(1, 0xB8 + page, LCD_CMD);
		lcd_Write(1, 0x40, LCD_CMD);

		for(column = 0; column < COLUMN_WIDTH; column++){
			lcd_Write(0, data, LCD_DAT);
			lcd_Write(1, data, LCD_DAT);
		}
	}
	lcd_Write(0, 0xC0, LCD_CMD);
	lcd_Write(1, 0xC0, LCD_CMD);
}

////////////////////////////////////////////////////////////////////////////
void lcd_Init(void)
{
	delay_ms(10);

	lcd_Write(0, 0x3F, LCD_CMD);
	lcd_Write(1, 0x3F, LCD_CMD);

	lcd_Clear(0x00);
}

////////////////////////////////////////////////////////////////////////////
void lcd_OutChar(BYTE x, BYTE y, BYTE dat)
{
	x = (x * FONT_WIDTH) + CHAR_OFFSET;

	if(x >= COLUMN_WIDTH){
		lcd_Write(1, 0xB8 + y, LCD_CMD);
		lcd_Write(1, 0x40 + (x - COLUMN_WIDTH), LCD_CMD);

		lcd_Write(1, font_tbl0[dat], LCD_DAT);
		lcd_Write(1, font_tbl1[dat], LCD_DAT);
		lcd_Write(1, font_tbl2[dat], LCD_DAT);
#ifdef _FONT_BIG_
		lcd_Write(1, font_tbl3[dat], LCD_DAT);
		lcd_Write(1, font_tbl4[dat], LCD_DAT);
#endif //_FONT_BIG_
	}
	else{
		lcd_Write(0, 0xB8 + y, LCD_CMD);
		lcd_Write(0, 0x40 + x, LCD_CMD);

		lcd_Write(0, font_tbl0[dat], LCD_DAT);
		lcd_Write(0, font_tbl1[dat], LCD_DAT);
		lcd_Write(0, font_tbl2[dat], LCD_DAT);
#ifdef _FONT_BIG_
		lcd_Write(0, font_tbl3[dat], LCD_DAT);
		lcd_Write(0, font_tbl4[dat], LCD_DAT);
#endif //_FONT_BIG_
	}
}

////////////////////////////////////////////////////////////////////////////
void lcd_ClearLine(BYTE y)
{
	BYTE i;

	lcd_Write(0, 0xB8 + y, LCD_CMD);
	lcd_Write(0, 0x40 + CHAR_OFFSET, LCD_CMD);

	lcd_Write(1, 0xB8 + y, LCD_CMD);
	lcd_Write(1, 0x40, LCD_CMD);

	for(i = 0; i < (COLUMN_WIDTH - CHAR_OFFSET); i++){
		lcd_Write(0, 0x00, LCD_DAT);
		lcd_Write(1, 0x00, LCD_DAT);
	}
}

////////////////////////////////////////////////////////////////////////////
void push_buff(BYTE bDat)
{
	rcv_stack[rcv_write] = bDat;

	rcv_write++;
	rcv_write = rcv_write % RCV_MAX;
}

////////////////////////////////////////////////////////////////////////////
BYTE get_sw()
{
	return (~PORTB & 0x70) >> 4;
}

////////////////////////////////////////////////////////////////////////////
void set_baud(BYTE bIndex)
{
	TXSTA = BaudInfo[bIndex].bTXSTA;
	RCSTA = BaudInfo[bIndex].bRCSTA;
	SPBRG = BaudInfo[bIndex].bSPBRG;
	RCIF = 0;

	push_buff(BaudInfo[bIndex].bBaudStr);
}

////////////////////////////////////////////////////////////////////////////
#INT_RB
void int_rb_isr(void)
{
	BYTE bIndex;

	bIndex = get_sw();

	if(bLastSW != bIndex){
		set_baud(bIndex);
	}
	bLastSW = bIndex;

	delay_ms(100);
}

////////////////////////////////////////////////////////////////////////////
#INT_RDA
void int_rda_isr(void)
{
	if(RCIF == 1){
		rcv_stack[rcv_write] = RCREG;

		rcv_write++;
		rcv_write = rcv_write % RCV_MAX;

		RCIF = 0;
	}
}

////////////////////////////////////////////////////////////////////////////
BYTE getc_buff(void)
{
	if(rcv_read != rcv_write){
		rcv_buff = rcv_stack[rcv_read];
		rcv_read++;
		rcv_read = rcv_read % RCV_MAX;
		return 1;
	}
	else{
		return 0;
	}
}

////////////////////////////////////////////////////////////////////////////
// C.
//
// IN:
//
// OUT:
//
// RETURN:
//
////////////////////////////////////////////////////////////////////////////
main()
{
	BYTE x = 0;
	BYTE y = 7;
	BYTE print_y = 0;
	BYTE i;

	setup_adc(NO_ANALOGS);          //Not Used
	set_tris_a(0b00000000);         //PORT A
	set_tris_b(0b01110000);         //PORT B
	set_tris_c(0b10000000);         //PORT C
	set_tris_d(0b00000000);         //PORT D
	set_tris_e(0b00000000);         //PORT E

	lcd_Init();

#ifdef _FONT_BIG_
	//LCDTCh̏.
	for(i = 0; i < SCREEN_LINE_NUM; i++){
		lcd_Write(1, 0xB8 + i, LCD_CMD);
		lcd_Write(1, 0x40 + (COLUMN_WIDTH - 2), LCD_CMD);
		lcd_Write(1, 0b00000001, LCD_DAT);
		lcd_Write(1, 0b11111111, LCD_DAT);

		lcd_Write(0, 0xB8 + i, LCD_CMD);
		lcd_Write(0, 0x40 + 0, LCD_CMD);
		lcd_Write(0, 0b11111111, LCD_DAT);
		lcd_Write(0, 0b00000001, LCD_DAT);
	}
#endif //_FONT_BIG_

	bLastSW = get_sw();
	set_baud(bLastSW);

	enable_interrupts(INT_RDA);
	enable_interrupts(INT_RB);
	enable_interrupts(GLOBAL);

	delay_ms(10);

	//LCD̃|[gl.
	LCD_RES = HIGH;
	LCD_RW = LOW;

	//ʒuɃJ[\\.
	lcd_OutChar(x, y, 0x5f);

	while(1){
		//Mf[^܂ő҂.
		while(getc_buff() == 0){
			;
		}

		switch(rcv_buff){
		case 0x0a:
			break;
		case 0x0d:
			//s}[Nt.
			lcd_OutChar(x, y, 0x7f);

			//sɈʒu߂.
			x = 0;

			//sXV.
			y++;
			y %= SCREEN_LINE_NUM;

			print_y++;
			print_y %= SCREEN_LINE_NUM;

			//̍sXy[XœhԂ.
			lcd_ClearLine(y);

			//XN[.
			lcd_Write(0, 0xC0 + (print_y * FONT_HEIGHT), LCD_CMD);
			lcd_Write(1, 0xC0 + (print_y * FONT_HEIGHT), LCD_CMD);

			//̈ʒuɃJ[\\.
			lcd_OutChar(x, y, 0x5f);

			break;
		default:
			if(rcv_buff > 128){
				lcd_OutChar(x, y, '?');
			}
			else{
				lcd_OutChar(x, y, rcv_buff);
			}

			x++;

			if(x >= LINE_CHAR_MAX){
				//sɈʒu߂.
				x = 0;

				//sXV.
				y++;
				y %= SCREEN_LINE_NUM;

				print_y++;
				print_y %= SCREEN_LINE_NUM;

				//̍sXy[XœhԂ.
				lcd_ClearLine(y);

				//XN[.
				lcd_Write(0, 0xC0 + (print_y * FONT_HEIGHT), LCD_CMD);
				lcd_Write(1, 0xC0 + (print_y * FONT_HEIGHT), LCD_CMD);
			}

			//̈ʒuɃJ[\\.
			lcd_OutChar(x, y, 0x5f);

			break;
		}
	}
}
